// Copyright 2005/2548 written by freegoldbar at yahoo dot com.
// All rights reserved. For private and educational use.
// Not for sale, commercial or military use.
// No warranties given. No suitability for any purpose.

#ifndef fannInterface_H
#define fannInterface_H

#include "doublefann.h"
#include "fann_cpp.h"

#include <boost/utility.hpp>
#include <boost/thread/thread.hpp>
#include <boost/thread/tss.hpp>
#include <boost/thread/xtime.hpp>
#include <limits>
#include <string>

typedef struct instance_struct : boost::noncopyable
{
    boost::mutex instance_mutex;
    boost::xtime last_access_time;
    unsigned long last_access_ip;

    std::string net_name;
    FANN::neural_net net;
    std::string train_name;
    FANN::training_data traindata;
    std::string test_name;
    FANN::training_data testdata;

    bool stop_training;
} instance;

extern boost::xtime::xtime_sec_t instance_expiry_time;
extern void purge_thread(void);

#endif // fannInterface_H
